package kz.project.printedFormsService.service;

import com.fasterxml.jackson.core.JsonProcessingException;
import kz.project.printedFormsService.data.dto.DocumentByDateDto;
import kz.project.printedFormsService.data.dto.DocumentByTemplateDto;
import kz.project.printedFormsService.exception.ValidationException;
import org.jetbrains.annotations.NotNull;

import java.time.LocalDate;
import java.util.Set;

public interface DocumentsService {

    @NotNull
    DocumentByDateDto getDocumentCountsByDate(@NotNull LocalDate startDate, @NotNull LocalDate endDate, @NotNull Set<String> projects);

    @NotNull
    DocumentByTemplateDto getDocumentCountsByTemplate(@NotNull LocalDate startDate, @NotNull LocalDate endDate, @NotNull Set<String> projects);
    void saveDocument(Long templateId) throws ValidationException, JsonProcessingException;
}
